diff -rupN seq24-rev48 adding win32/src/options.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/options.cpp
--- seq24-rev48 adding win32/src/options.cpp	2009-05-20 20:30:46.656250000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/options.cpp	2009-05-20 20:30:55.265625000 -0500
@@ -21,12 +21,77 @@
 #include "options.h"
 #include <sstream>
 
+// tooltip helper, for old vs new gtk...
+#if GTK_MINOR_VERSION >= 12
+#   define add_tooltip( obj, text ) obj->set_tooltip_text( text);
+#else
+#   define add_tooltip( obj, text ) tooltips->set_tip( *obj, text );
+#endif
 
 const int c_status = 0;
 const int c_status_inv = 1;
 const int c_d1 = 2;
 const int c_d2 = 3;
 const int c_d3 = 4;
+enum
+{
+    e_keylabelsonsequence = 9999
+};
+
+
+// GTK text edit widget for getting keyboard button values (for binding keys)
+// put cursor in text box, hit a key, something like  'a' (42)  appears...
+// each keypress replaces the previous text.
+// also supports keyevent and keygroup maps in the perform class
+class KeyBindEntry : public Entry
+{
+public:
+    enum type { location, events, groups };
+    KeyBindEntry(   type t,
+                    unsigned int* location_to_write = NULL,
+                    perform* p = NULL,
+                    long s = 0 ) :  Entry(),
+                                    m_key( location_to_write ),
+                                    m_type( t ),
+                                    m_perf( p ),
+                                    m_slot( s )
+    {
+        switch (m_type)
+        {
+            case location: if (m_key) set( *m_key ); break;
+            case events: set( m_perf->lookup_keyevent_key( m_slot ) ); break;
+            case groups: set( m_perf->lookup_keygroup_key( m_slot ) ); break;
+        }
+    }
+    void set( unsigned int val )
+    {
+        char buf[256] = "";
+        char* special = key2text( val );
+        if (special)
+            sprintf( &buf[strlen(buf)], "%s ", special );
+        else
+            sprintf( &buf[strlen(buf)], "'%c' ", (char)val );
+        sprintf( &buf[strlen(buf)], "(%u)", val );
+        set_text( buf );
+        set_width_chars( strlen(buf)-3 );
+    }
+    virtual bool on_key_press_event(GdkEventKey* event)
+    {
+        Entry::on_key_press_event( event );
+        set( event->keyval );
+        switch (m_type)
+        {
+            case location: if (m_key) *m_key = event->keyval; break;
+            case events: m_perf->set_key_event( event->keyval, m_slot ); break;
+            case groups: m_perf->set_key_group( event->keyval, m_slot ); break;
+        }
+    }
+    unsigned int* m_key;
+    type m_type;
+    perform* m_perf;
+    long m_slot;
+};
+
 
 options::options (Gtk::Window & parent, perform * a_p):
     Gtk::Dialog ("Options", parent, true, true)
@@ -72,16 +137,14 @@ options::options (Gtk::Window & parent, 
         
         
         Gtk::RadioButton * rb_off = manage (new RadioButton ("Off"));
-        tooltips->set_tip (*rb_off,
-                "Midi Clock will be disabled.");
-
+        add_tooltip( rb_off, "Midi Clock will be disabled.");
         
         Gtk::RadioButton * rb_on = manage (new RadioButton ("On (Pos)"));
-        tooltips->set_tip (*rb_on,
+        add_tooltip( rb_on,
                 "Midi Clock will be sent. Midi Song Position and Midi Continue will be sent if starting greater than tick 0 in song mode, otherwise Midi Start is sent.");
 
         Gtk::RadioButton * rb_mod = manage (new RadioButton ("On (Mod)"));
-        tooltips->set_tip (*rb_mod, "Midi Clock will be sent.  Midi Start will be sent and clocking will begin once the song position has reached the modulo of the specified Size. (Used for gear that doesn't respond to Song Position)");
+        add_tooltip( rb_mod, "Midi Clock will be sent.  Midi Start will be sent and clocking will begin once the song position has reached the modulo of the specified Size. (Used for gear that doesn't respond to Song Position)");
 
         Gtk::RadioButton::Group group = rb_off->get_group ();
         rb_on->set_group (group);
@@ -120,6 +183,30 @@ options::options (Gtk::Window & parent, 
     
     clock_mod_adj->signal_value_changed().connect( sigc::bind(mem_fun(*this,&options::clock_mod_callback),clock_mod_adj));
 
+    // add controls for input method
+    {
+        Adjustment *adj = new Adjustment( global_interactionmethod, 0, e_number_of_interactions-1, 1 );
+        SpinButton *spin = new SpinButton( *adj );
+
+        HBox *hbox2 = manage (new HBox ());
+        HBox *hbox3 = manage (new HBox ());
+
+        //m_spinbutton_bpm->set_editable( false );
+        interaction_method_label = new Label( " Input Method " );
+        hbox2->pack_start(*(manage( interaction_method_label )), false, false, 4);
+        hbox2->pack_start(*spin, false, false );
+
+        vbox->pack_start( *hbox2, false, false );
+
+        interaction_method_desc_label = new Label( " ----- " );
+        hbox3->pack_start(*(manage( interaction_method_desc_label )), false, false, 4);
+        vbox->pack_start(*hbox3, false, false );
+
+        adj->signal_value_changed().connect( SigC::bind(mem_fun(*this,&options::interaction_method_callback),adj));
+
+        // force it to refresh.
+        interaction_method_callback( adj );
+    }
 
     // Input Buses
     buses = m_perf->get_master_midi_bus ()->get_num_in_buses ();
@@ -141,7 +228,125 @@ options::options (Gtk::Window & parent, 
 
         vbox->pack_start (*check, false, false);
     }
-    
+
+    // KeyBoard keybinding setup (editor for .seq24rc keybindings.
+    vbox = manage (new VBox ());
+    m_notebook->pages ().push_back (Notebook_Helpers::TabElem (*vbox, "Keyboard"));
+    {
+        Label* label;
+        KeyBindEntry* entry;
+        HBox *hbox;
+
+        #define AddKey(text, integer) \
+            label = manage (new Label( text )); \
+            hbox->pack_start (*label, false, false, 4); \
+            entry = manage (new KeyBindEntry( KeyBindEntry::location, &integer )); \
+            hbox->pack_start (*entry, false, false, 4);
+        #define AddKeyL(text) \
+            label = manage (new Label( text )); \
+            hbox->pack_start (*label, false, false, 4);
+        #define AddKeyM(text, type, slot) \
+            label = manage (new Label( text )); \
+            hbox->pack_start (*label, false, false, 4); \
+            entry = manage (new KeyBindEntry( type, NULL, m_perf, slot )); \
+            hbox->pack_start (*entry, false, false, 4);
+
+        hbox = manage (new HBox ());
+        check = manage (new CheckButton ("show key labels on sequences", 0));
+        check->signal_toggled ().
+            connect (bind (mem_fun (*this, &options::input_callback), (int)e_keylabelsonsequence, check));
+        check->set_active (m_perf->m_show_ui_sequence_key);
+        vbox->pack_start (*check, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "stop:", m_perf->m_key_stop );
+        AddKey( "start:", m_perf->m_key_start );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "bpm dn:", m_perf->m_key_bpm_dn );
+        AddKey( "bpm up:", m_perf->m_key_bpm_up );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "snpsht1:", m_perf->m_key_snapshot_1 );
+        AddKey( "snpsht2:", m_perf->m_key_snapshot_2 );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "replace:", m_perf->m_key_replace );
+        AddKey( "queue:", m_perf->m_key_queue );
+        AddKey( "keep queue:", m_perf->m_key_keep_queue );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "scrnset dn:", m_perf->m_key_screenset_dn );
+        AddKey( "scrnset up:", m_perf->m_key_screenset_up );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "set plying scrnset:", m_perf->m_key_set_playing_screenset );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKeyL( "sequence toggle keys >>" );
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        std::map<unsigned int, long>::const_iterator it;
+        int x = 0;
+        for (int ss = 0; ss < 32; ++ss)
+        {
+            int s = (ss%8) * 4 + ss/8; // count this way... 0,4,8,16...
+            unsigned int keycode = m_perf->lookup_keyevent_key( s );
+            char buf[16];
+            sprintf( buf, "%d", s );
+            AddKeyM( buf, KeyBindEntry::events, s );
+            ++x;
+            if (x == 8)
+            {
+                vbox->pack_start (*hbox, false, false);
+                hbox = manage (new HBox ());
+                x = 0;
+            }
+        }
+        vbox->pack_start (*hbox, false, false);
+        
+        hbox = manage (new HBox ());
+        AddKeyL( "mute-group slots >>" );
+        vbox->pack_start (*hbox, false, false);
+        
+        hbox = manage (new HBox ());
+        x = 0;
+        for (int s = 0; s < 32; ++s)
+        {
+            unsigned int keycode = m_perf->lookup_keygroup_key( s );
+            char buf[16];
+            sprintf( buf, "%d", s );
+            AddKeyM( buf, KeyBindEntry::groups, s );
+            ++x;
+            if (x == 8)
+            {
+                vbox->pack_start (*hbox, false, false);
+                hbox = manage (new HBox ());
+                x = 0;
+            }
+        }
+        vbox->pack_start (*hbox, false, false);
+
+        hbox = manage (new HBox ());
+        AddKey( "learn (while pressing a mute-group key):", m_perf->m_key_group_learn );
+        AddKey( "disable:", m_perf->m_key_group_off );
+        AddKey( "enable:", m_perf->m_key_group_on );
+        vbox->pack_start (*hbox, false, false);
+        
+        #undef AddKeyL
+        #undef AddKey
+    }
+
 #ifdef JACK_SUPPORT
     // Jack options menu
     VBox *vbox2 = manage (new VBox ());
@@ -152,7 +357,7 @@ options::options (Gtk::Window & parent, 
 
     check = manage (new CheckButton ("Jack Transport"));
     check->set_active (global_with_jack_transport);
-    tooltips->set_tip (*check, "Enable sync with JACK Transport.");
+    add_tooltip( check, "Enable sync with JACK Transport.");
     check->signal_toggled ().
         connect (bind
                 (mem_fun (*this, &options::transport_callback), e_jack_transport,
@@ -161,7 +366,7 @@ options::options (Gtk::Window & parent, 
 
     check = manage (new CheckButton ("Transport Master"));
     check->set_active (global_with_jack_master);
-    tooltips->set_tip (*check, "Seq24 will attempt to serve as JACK Master.");
+    add_tooltip( check, "Seq24 will attempt to serve as JACK Master.");
     check->signal_toggled ().
         connect (bind
                 (mem_fun (*this, &options::transport_callback), e_jack_master,
@@ -171,7 +376,7 @@ options::options (Gtk::Window & parent, 
 
     check = manage (new CheckButton ("Master Conditional"));
     check->set_active (global_with_jack_master_cond);
-    tooltips->set_tip (*check,
+    add_tooltip( check,
             "Seq24 will fail to be master if there is already a master set.");
     check->signal_toggled ().
         connect (bind
@@ -182,11 +387,11 @@ options::options (Gtk::Window & parent, 
 
 
     Gtk::RadioButton * rb_live = manage (new RadioButton ("Live Mode"));
-    tooltips->set_tip (*rb_live,
+    add_tooltip( rb_live,
             "Playback will be in live mode.  Use this to allow muting and unmuting of loops.");
 
     Gtk::RadioButton * rb_perform = manage (new RadioButton ("Song Mode"));
-    tooltips->set_tip (*rb_perform, "Playback will use the song editors data.");
+    add_tooltip( rb_perform, "Playback will use the song editors data.");
 
     Gtk::RadioButton::Group group = rb_live->get_group ();
     rb_perform->set_group (group);
@@ -209,13 +414,13 @@ options::options (Gtk::Window & parent, 
     vbox2->pack_start (*rb_perform, false, false);
 
     Gtk::Button * button = manage (new Button ("Connect"));
-    tooltips->set_tip (*button, "Connect to Jack.");
+    add_tooltip( button, "Connect to Jack.");
     button->signal_clicked().connect(bind(mem_fun(*this,
                     &options::transport_callback), e_jack_connect, button));
     vbox2->pack_start (*button, false, false);
 
     button = manage (new Button ("Disconnect"));
-    tooltips->set_tip (*button, "Disconnect Jack.");
+    add_tooltip( button, "Disconnect Jack.");
     button->signal_clicked().connect(bind(mem_fun(*this,
                     &options::transport_callback), e_jack_disconnect, button));
     vbox2->pack_start (*button, false, false);
@@ -254,12 +459,35 @@ options::clock_mod_callback( Adjustment 
     midibus::set_clock_mod((int)adj->get_value());
 }
  
+void
+options::interaction_method_callback( Adjustment *adj )
+{
+    global_interactionmethod = (interaction_method_e)(int)adj->get_value();
+    std::string text = " Interaction Method (";
+    text += c_interaction_method_names[(int)adj->get_value()];
+    text += "):  ";
+    interaction_method_label->set_text( text.c_str() );
+    
+    text = "     (";
+    text += c_interaction_method_descs[(int)adj->get_value()];
+    text += ") ";
+    interaction_method_desc_label->set_text( text.c_str() );
+}
+
 
     void
 options::input_callback (int a_bus, Button * i_button)
 {
     CheckButton *a_button = (CheckButton *) i_button;
     bool input = a_button->get_active ();
+    if (9999 == a_bus) {
+        m_perf->m_show_ui_sequence_key = input;
+        for (int i=0; i< c_max_sequence; i++ ){
+            if (m_perf->get_sequence( i ))
+                m_perf->get_sequence( i )->set_dirty();
+        }
+        return;
+    }
     m_perf->get_master_midi_bus ()->set_input (a_bus, input);
 }
 
diff -rupN seq24-rev48 adding win32/src/options.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/options.h
--- seq24-rev48 adding win32/src/options.h	2009-05-20 20:30:46.671875000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/options.h	2009-05-20 20:30:55.281250000 -0500
@@ -55,6 +55,7 @@ using namespace Gtk;
 
 
 
+
 class options : public Gtk::Dialog
 {
 
@@ -63,6 +64,8 @@ class options : public Gtk::Dialog
     perform *m_perf;
 
     Button  *m_button_ok;
+    Label* interaction_method_label;
+    Label* interaction_method_desc_label;
 
 
     Table   *m_table;
@@ -85,8 +88,10 @@ class options : public Gtk::Dialog
     void clock_callback_mod( int a_bus, RadioButton *a_button );
 
     void clock_mod_callback( Adjustment *adj );
+    void interaction_method_callback( Adjustment *adj );
     
     void input_callback( int a_bus, Button *a_button );
+
     void transport_callback( button a_type, Button *a_button );
     
 public:
diff -rupN seq24-rev48 adding win32/src/optionsfile.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/optionsfile.cpp
--- seq24-rev48 adding win32/src/optionsfile.cpp	2009-05-20 20:30:46.703125000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/optionsfile.cpp	2009-05-20 20:30:55.312500000 -0500
@@ -92,6 +92,35 @@ optionsfile::parse( perform *a_perf )
          
         next_data_line( &file );
     }
+    /* group midi control */
+    line_after( &file, "[mute-group]");
+
+    int gtrack = 0;
+    sscanf( m_line, "%d", &gtrack );
+    next_data_line( &file );
+   
+    int mtx[c_seqs_in_set], j=0;
+    for (int i=0; i< c_seqs_in_set; i++) {
+        a_perf->select_group_mute(j);
+        sscanf (m_line, "%d [%d %d %d %d %d %d %d %d] [%d %d %d %d %d %d %d %d] [%d %d %d %d %d %d %d %d] [%d %d %d %d %d %d %d %d]",
+            &j,
+            &mtx[0], &mtx[1], &mtx[2], &mtx[3],
+            &mtx[4], &mtx[5], &mtx[6], &mtx[7],
+           
+            &mtx[8], &mtx[9], &mtx[10], &mtx[11],
+            &mtx[12], &mtx[13], &mtx[14], &mtx[15],
+             
+            &mtx[16], &mtx[17], &mtx[18], &mtx[19],
+            &mtx[20], &mtx[21], &mtx[22], &mtx[23],
+             
+            &mtx[24], &mtx[25], &mtx[26], &mtx[27],
+            &mtx[28], &mtx[29], &mtx[30], &mtx[31]);
+        for (int k=0; k< c_seqs_in_set; k++) {
+            a_perf->set_group_mute_state(k, mtx[k]);
+        }
+        j++;
+        next_data_line( &file );
+    }
 
     line_after( &file, "[midi-clock]" );
     long buses = 0;
@@ -114,28 +143,60 @@ optionsfile::parse( perform *a_perf )
 
     a_perf->key_events.clear();
     
-    
+
     for ( int i=0; i<keys; ++i ){
         
         long key = 0, seq = 0;
         sscanf( m_line, "%ld %ld", &key, &seq );
-        a_perf->key_events[key] = seq;
+        a_perf->set_key_event( key, seq );
+        next_data_line( &file );
+    }
+    line_after( &file, "[keyboard-group]" );
+    long groups = 0;
+    sscanf( m_line, "%ld", &groups );
+    next_data_line( &file );
+
+    a_perf->key_groups.clear();
+   
+   
+    for ( int i=0; i<groups; ++i ){
+       
+        long key = 0, group = 0;
+        sscanf( m_line, "%ld %ld", &key, &group );
+        a_perf->set_key_group( key, group );
         next_data_line( &file );
     }
 
+
     sscanf( m_line, "%u %u", &a_perf->m_key_bpm_up,
                              &a_perf->m_key_bpm_dn );
     next_data_line( &file );
-
-    sscanf( m_line, "%u %u", &a_perf->m_key_screenset_up,
-                             &a_perf->m_key_screenset_dn );
+    sscanf( m_line, "%u %u %u", &a_perf->m_key_screenset_up,
+                             &a_perf->m_key_screenset_dn,
+                             &a_perf->m_key_set_playing_screenset);
+   
+
+     next_data_line( &file );
+
+    sscanf( m_line, "%u %u %u", &a_perf->m_key_group_on,
+                              &a_perf->m_key_group_off,
+                             &a_perf->m_key_group_learn);
+   
     next_data_line( &file );
 
-    sscanf( m_line, "%u %u %u %u",
+    sscanf( m_line, "%u %u %u %u %u",
             &a_perf->m_key_replace,
             &a_perf->m_key_queue,
             &a_perf->m_key_snapshot_1,
-            &a_perf->m_key_snapshot_2 );
+            &a_perf->m_key_snapshot_2,
+            &a_perf->m_key_keep_queue);
+
+    next_data_line( &file );
+    sscanf( m_line, "%ld", &a_perf->m_show_ui_sequence_key );
+    next_data_line( &file );
+    sscanf( m_line, "%ld", &a_perf->m_key_start );
+    next_data_line( &file );
+    sscanf( m_line, "%ld", &a_perf->m_key_stop );
 
     line_after( &file, "[jack-transport]" );
     long flag = 0;
@@ -187,7 +248,12 @@ optionsfile::parse( perform *a_perf )
     if (m_line[0] == '/')
         last_used_dir.assign(m_line);
 
-
+    /* interaction method  */
+    long method = 0;
+    line_after( &file, "[interaction-method]" );
+    sscanf( m_line, "%ld", &method );
+    global_interactionmethod = (interaction_method_e)method;
+    
     file.close();
 
     return true;
@@ -221,13 +287,20 @@ optionsfile::write( perform *a_perf  )
 
         switch( i ){
 
-            case c_midi_control_bpm_up       :  file << "# bpm up\n"; break;
+            /* 32 mute for channel
+               32 group mute */
+            case c_seqs_in_set               :  file << "# mute in group\n"; break;
+           case c_midi_control_bpm_up       :  file << "# bpm up\n"; break;
             case c_midi_control_bpm_dn       :  file << "# bpm down\n"; break;
             case c_midi_control_ss_up        :  file << "# screen set up\n"; break;
             case c_midi_control_ss_dn        :  file << "# screen set down\n"; break;
             case c_midi_control_mod_replace  :  file << "# mod replace\n"; break;
             case c_midi_control_mod_snapshot :  file << "# mod snapshot\n"; break;
             case c_midi_control_mod_queue    :  file << "# mod queue\n"; break;
+            case c_midi_control_mod_gmute    :  file << "# mod gmute\n"; break;
+            case c_midi_control_mod_glearn   :  file << "# mod glearn\n"; break;
+            case c_midi_control_play_ss      :  file << "# screen set play\n"; break;
+           
 
             default: break;
         }
@@ -260,6 +333,33 @@ optionsfile::write( perform *a_perf  )
 
         file << string(outs) << "\n";
     }
+   
+    /* group midi control */
+    file << "\n\n\n[mute-group]\n";
+   
+    int mtx[c_seqs_in_set];
+    file <<  c_gmute_tracks << "\n";
+    for (int j=0; j < c_seqs_in_set; j++ ){
+        a_perf->select_group_mute(j);
+        for (int i=0; i < c_seqs_in_set; i++) {
+            mtx[i] = a_perf->get_group_mute_state(i);
+        }
+        sprintf (outs, "%d [%1d %1d %1d %1d %1d %1d %1d %1d] [%1d %1d %1d %1d %1d %1d %1d %1d] [%1d %1d %1d %1d %1d %1d %1d %1d] [%1d %1d %1d %1d %1d %1d %1d %1d]",
+            j,
+            mtx[0], mtx[1], mtx[2], mtx[3],
+            mtx[4], mtx[5], mtx[6], mtx[7],
+           
+            mtx[8], mtx[9], mtx[10], mtx[11],
+            mtx[12], mtx[13], mtx[14], mtx[15],
+             
+            mtx[16], mtx[17], mtx[18], mtx[19],
+            mtx[20], mtx[21], mtx[22], mtx[23],
+             
+            mtx[24], mtx[25], mtx[26], mtx[27],
+            mtx[28], mtx[29], mtx[30], mtx[31]);
+       
+        file << string(outs) << "\n";
+    }
 
  
 
@@ -305,35 +405,84 @@ optionsfile::write( perform *a_perf  )
     file << "# not connect to other clients\n";
     file << global_manual_alsa_ports << "\n";
     
+    /* interaction-method */
+    int x = 0;
+    file << "\n\n\n[interaction-method]\n";
+    while (c_interaction_method_names[x] && c_interaction_method_descs[x])
+    {
+        file << "# " << x << " - '" << c_interaction_method_names[x]
+                     << "' (" << c_interaction_method_descs[x] << ")\n";
+        ++x;
+    }
+    file << global_interactionmethod << "\n";
+
  
 
     file << "\n\n\n[keyboard-control]\n";
     file << "# Key #, Sequence # \n";
-    file << c_seqs_in_set << "\n";
+    file << (a_perf->key_events.size() < c_seqs_in_set ?
+             a_perf->key_events.size() : c_seqs_in_set) << "\n";
 
-    for( std::map<long,long>::iterator i = a_perf->key_events.begin();
+    for( std::map<unsigned int,long>::const_iterator i = a_perf->key_events.begin();
          i != a_perf->key_events.end(); ++i ){
         
-        sprintf( outs, "%ld  %ld", i->first, i->second );
+        sprintf( outs, "%ld  %ld        # %s", i->first, i->second, key2text( i->first ) );
+        file << string(outs) << "\n";
+    }
+    file << "\n\n\n[keyboard-group]\n";
+    file << "# Key #, group # \n";
+    file << (a_perf->key_groups.size() < c_seqs_in_set ?
+             a_perf->key_groups.size() : c_seqs_in_set) << "\n";
+
+    for( std::map<unsigned int,long>::const_iterator i = a_perf->key_groups.begin();
+         i != a_perf->key_groups.end(); ++i ){
+       
+        sprintf( outs, "%ld  %ld        # %s", i->first, i->second, key2text(i->first) );
         file << string(outs) << "\n";
     }
 
     file << "# bpm up, down\n"
-         << a_perf->m_key_bpm_up
-         << " "
-         << a_perf->m_key_bpm_dn << "\n";
-
-    file << "# screen set up, down\n"
-         << a_perf->m_key_screenset_up
-         << " "
-         << a_perf->m_key_screenset_dn
-         << "\n";
-
-    file << "# replace, queue, snapshot_1, snapshot 2\n"
+         << a_perf->m_key_bpm_up << " "
+         << a_perf->m_key_bpm_dn << "        # "
+         << key2text( a_perf->m_key_bpm_up ) << " "
+         << key2text( a_perf->m_key_bpm_dn ) << "\n";
+
+    file << "# screen set up, down, play\n"
+         << a_perf->m_key_screenset_up << " "
+         << a_perf->m_key_screenset_dn << " "
+         << a_perf->m_key_set_playing_screenset << "        # "
+         << key2text( a_perf->m_key_screenset_up ) << " "
+         << key2text( a_perf->m_key_screenset_dn ) << " "
+         << key2text( a_perf->m_key_set_playing_screenset ) << "\n";
+
+    file << "# group on, off, learn\n"
+         << a_perf->m_key_group_on << " "
+         << a_perf->m_key_group_off << " "
+         << a_perf->m_key_group_learn << "        # "
+         << key2text( a_perf->m_key_group_on ) << " "
+         << key2text( a_perf->m_key_group_off ) << " "
+         << key2text( a_perf->m_key_group_learn ) << "\n";
+   
+    file << "# replace, queue, snapshot_1, snapshot 2, keep queue\n" 
          << a_perf->m_key_replace << " "
          << a_perf->m_key_queue << " "
          << a_perf->m_key_snapshot_1 << " "
-         << a_perf->m_key_snapshot_2 << "\n";
+         << a_perf->m_key_snapshot_2 << " "
+         << a_perf->m_key_keep_queue << "        # "
+         << key2text( a_perf->m_key_replace ) << " "
+         << key2text( a_perf->m_key_queue ) << " "
+         << key2text( a_perf->m_key_snapshot_1 ) << " "
+         << key2text( a_perf->m_key_snapshot_2 ) << " "
+         << key2text( a_perf->m_key_keep_queue ) << "\n";
+
+    file << a_perf->m_show_ui_sequence_key
+         << "        # show_ui_sequence_key (1=true/0=false)\n";
+    file << a_perf->m_key_start << "        # "
+         << key2text( a_perf->m_key_start )
+         << " start sequencer\n";
+    file << a_perf->m_key_stop << "        # "
+         << key2text( a_perf->m_key_stop )
+         << " stop sequencer\n";
 
     file << "\n\n\n[jack-transport]\n\n"
 
